﻿using SampleApp.Models;
using Syncfusion.JavaScript;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataSources;
using MVCSampleBrowser.Models;

namespace SampleApp.Controllers
{
    public class HomeController : Controller
    {
            
        public ActionResult Index()
        {
            var DataSource = OrderRepository.GetAllRecords();
            ViewData["datasource"] = DataSource;
            return View();         
        }
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords();
            int count = Data.AsQueryable().Count();
            DataOperations operation = new DataOperations();
            Data = operation.Execute(Data, dm);
            if (dm.Where != null)
            {
                count = Data.AsQueryable().Count();//updates the origninal record count after filtering
            }
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }
        public object Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        [HttpGet]
        public ActionResult Productpartial()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewData["datasource"] = DataSource;
            return PartialView("_partial",ViewData);
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }
            public long OrderID { get; set; }
            public string OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
    }
}